<?php
/***************************************************************    
*  Copyright notice    
*      
*  (c) 2005 Chi Hoang    
*    
*  All rights reserved    
*    
*  This script is part of the Typo3 project. The Typo3 project is     
*  free software; you can redistribute it and/or modify    
*  it under the terms of the GNU General Public License as published by    
*  the Free Software Foundation; either version 2 of the License, or    
*  (at your option) any later version.    
*     
*  The GNU General Public License can be found at   
*  http://www.gnu.org/copyleft/gpl.html.    
*     
*  This script is distributed in the hope that it will be useful,    
*  but WITHOUT ANY WARRANTY; without even the implied warranty of    
*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the    
*  GNU General Public License for more details.    
*    
*  This copyright notice MUST APPEAR in all copies of the script!    
***************************************************************/

class ux_tslib_fe extends tslib_fe {

	/**
	 * Setting the language key that'll be used by the current page.
	 * In this function it should be checked, 1) that this language exists, 2) that a page_overlay_record exists, .. and if not the default language, 0 (zero), should be set.
	 *
	 * @return	void
	 * @access private
	 */
	function settingLanguage()	{

                // Get values from TypoScript:
		$this->sys_language_uid = $this->sys_language_content = intval($this->config['config']['sys_language_uid']);
		list($this->sys_language_mode,$sys_language_content) = t3lib_div::trimExplode(';', $this->config['config']['sys_language_mode']);
		$this->sys_language_contentOL = $this->config['config']['sys_language_overlay'];

                // If sys_language_uid is set to another language than default:
		if ($this->sys_language_uid>0)	{
				// Request the overlay record for the sys_language_uid:
			$olRec = $this->sys_page->getPageOverlay($this->id, $this->sys_language_uid);
			if (!count($olRec))	{

                                // If no OL record exists and a foreign language is asked for...
				if ($this->sys_language_uid)	{

                                        // If requested translation is not available:
					if ($this->page['l18n_cfg']&2)	{
                                                
                                                if ($this->config['config']['sys_language_error_pid']) {                
                                                    
                                                    $this->id = $this->config['config']['sys_language_error_pid'];
                                                    $this->fetch_the_id();                                                    
                                                    $this->initTemplate();                                                    
                                                    $this->getFromCache();
                                                    $this->getConfigArray();
                      
                                                    if ($this->sys_language_uid>0) {
                                                        $olRec = $this->sys_page->getPageOverlay($this->id, $this->sys_language_uid);
                                                        if (!count($olRec)) {
                                                            $this->pageNotFoundAndExit('Page is not available in the requested language.');                                                             
                                                        } else {
                                                            $this->page = $this->sys_page->getPageOverlay($this->page, $this->sys_language_uid);
                                                            $this->page['content_from_pid'] = $this->id;
                                                        }
                                                    }
                                                
                                                } else {
                                                    $this->pageNotFoundAndExit('Page is not available in the requested language.');                                                    
                                                }

					} else {
						switch((string)$this->sys_language_mode)	{
							case 'strict':
								$this->pageNotFoundAndExit('Page is not available in the requested language (strict).');
							break;
							case 'content_fallback':
								$fallBackOrder = t3lib_div::intExplode(',', $sys_language_content);
								foreach($fallBackOrder as $orderValue)	{
									if (!strcmp($orderValue,'0') || count($this->sys_page->getPageOverlay($this->id, $orderValue)))	{
										$this->sys_language_content = $orderValue;	// Setting content uid (but leaving the sys_language_uid)
										break;
									}
								}
							break;
							default:
									// Default is that everything defaults to the default language...
								$this->sys_language_uid = $this->sys_language_content = 0;
							break;
						}
					}
				}
			} else {
                                // Setting sys_language if an overlay record was found (which it is only if a language is used)
				$this->page = $this->sys_page->getPageOverlay($this->page, $this->sys_language_uid);
			}
		}

			// Setting sys_language_uid inside sys-page:
		$this->sys_page->sys_language_uid = $this->sys_language_uid;

			// If default translation is not available:
		if ((!$this->sys_language_uid || !$this->sys_language_content) && $this->page['l18n_cfg']&1)	{
                
                        if ($this->config['config']['sys_language_error_pid']) {                
                                                    
                            $this->id = $this->config['config']['sys_language_error_pid'];
                            $this->fetch_the_id();                                                    
                            $this->initTemplate();                                                    
                            $this->getFromCache();
                            $this->getConfigArray();

                            $this->page = $this->sys_page->getPageOverlay($this->page, $this->sys_language_uid);
                            $this->page['content_from_pid'] = $this->id;
                            if ($this->sys_language_uid>0) {
                                $olRec = $this->sys_page->getPageOverlay($this->id, $this->sys_language_uid);
                                if (!count($olRec)) {
                                    $this->pageNotFoundAndExit('Page is not available in the requested language.');                                                             
                                }
                            }
                                                
                        } else {
                            $this->pageNotFoundAndExit('Page is not available in default language.');
                        }              
                
                }

			// Updating content of the two rootLines IF the language key is set!
		if ($this->sys_language_uid && is_array($this->tmpl->rootLine))	{
			reset($this->tmpl->rootLine);
			while(list($rLk)=each($this->tmpl->rootLine))	{
				$this->tmpl->rootLine[$rLk] = $this->sys_page->getPageOverlay($this->tmpl->rootLine[$rLk]);
			}
		}
		if ($this->sys_language_uid && is_array($this->rootLine))	{
			reset($this->rootLine);
			while(list($rLk)=each($this->rootLine))	{
				$this->rootLine[$rLk] = $this->sys_page->getPageOverlay($this->rootLine[$rLk]);
			}
		}

			// Finding the ISO code:
		if (t3lib_extMgm::isLoaded('static_info_tables') && $this->sys_language_content)	{	// using sys_language_content because the ISO code only (currently) affect content selection from FlexForms - which should follow "sys_language_content"
			$sys_language_row = $this->sys_page->getRawRecord('sys_language',$this->sys_language_content,'static_lang_isocode');
			if (is_array($sys_language_row) && $sys_language_row['static_lang_isocode'])	{
				$stLrow = $this->sys_page->getRawRecord('static_languages',$sys_language_row['static_lang_isocode'],'lg_iso_2');
				$this->sys_language_isocode = $stLrow['lg_iso_2'];
			}
		}

			// Setting softMergeIfNotBlank:
		$table_fields = t3lib_div::trimExplode(',', $this->config['config']['sys_language_softMergeIfNotBlank'],1);
		foreach($table_fields as $TF)	{
			list($tN,$fN) = explode(':',$TF);
			$this->TCAcachedExtras[$tN]['l10n_mode'][$fN] = 'mergeIfNotBlank';
		}
	}
        
}

?>